package de.uni_marburg.powersort.benchmark;

import de.uni_marburg.powersort.data.CompetitionEnum;
import de.uni_marburg.powersort.data.DataEnum;
import de.uni_marburg.powersort.sort.SortEnum;
import org.openjdk.jmh.annotations.Benchmark;
import org.openjdk.jmh.annotations.Param;
import org.openjdk.jmh.annotations.Scope;
import org.openjdk.jmh.annotations.State;

/*
 * Benchmark state parameters
 *
 * Quote from JMH:
 * State objects naturally encapsulate the state on which benchmark is working on.
 */
@State(Scope.Benchmark)
public class JmhCompetition extends JmhBase {
    @Param()
    CompetitionEnum dataEnum;
    @Param()
    SortEnum sortEnum;

    @Override
    DataEnum getDataEnum(){
        return dataEnum;
    }
    @Override
    SortEnum getSortEnum(){
        return sortEnum;
    }

    @Benchmark
    public void benchmark() {
        sortImpl.sort(workingCopy);
    }
}
