package de.uni_marburg.powersort.sort;

import java.util.Arrays;
import java.util.Comparator;

/**
 * Same class and method interface as TimSort.java with its sort() method.
 * <p>
 * Uses Arrays.sort() for sorting.
 * But calls it a.length times which makes this implementation really inefficient.
 */
class DummySort2 {
    public static <T> void sort(T[] a, int lo, int hi, Comparator<? super T> c,
                                T[] work, int workBase, int workLen) {
        assert lo == 0;
        assert hi == a.length;
        assert work == null;

        for (int i = 0; i < a.length; i++) {
            Arrays.sort(a, c);
        }
    }
}
