package de.uni_marburg.powersort.MSort;

import static de.uni_marburg.powersort.MSort.IMPL_M_1.*;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import de.uni_marburg.powersort.benchmark.NaturalOrder;

public class PowerSortT {

        public static void main(String[] args) {
            testFillWithAscRunsHighToLow();
            testMerge();
            testMergeInplace();
            testExtendRun();
            testPower();
            testPowerFast();
            testMergeTopmost2();
            testPowerSort();
        }

        // Test for fillWithAscRunsHighToLow
        public static void testFillWithAscRunsHighToLow() {
            Integer[] A = new Integer[10];
            int[] runLengths = {2, 3, 5};
            int runLenFactor = 1;
            fillWithAscRunsHighToLow(A, runLengths, runLenFactor);
            System.out.println("Test fillWithAscRunsHighToLow: " + A);
        }

        // Test for merge
        public static void testMerge() {
            Integer[] run1 ={1,4,6};
            Integer []run2 = {2, 3, 5};
            Integer[] result = merge(run1, run2, NaturalOrder.INSTANCE);
            System.out.println("Test merge: " + result);
        }

        // Test for mergeInplace
        public static void testMergeInplace() {
            Integer[] A = {1,4,6,2,3,5};
            mergeInplace(A, 0, 3, 6,NaturalOrder.INSTANCE);
            System.out.println("Test mergeInplace: " + A);
        }

        // Test for extendRun
        public static void testExtendRun() {
            Integer [] A = {1, 2, 3, 6, 5, 4};
            int endIndex = extendRun(A, 0,NaturalOrder.INSTANCE);
            System.out.println("Test extendRun (from 0): " + endIndex);
            System.out.println("Modified List: " + A);
        }

        // Test for power
        public static void testPower() {
            int[] run1 = {0, 3};
            int[] run2 = {3, 3};
            int n = 6;
            int powerValue = power(run1, run2, n);
            System.out.println("Test power: " + powerValue);
        }

        // Test for powerFast
        public static void testPowerFast() {
            int[] run1 = {0, 3};
            int[] run2 = {3, 3};
            int n = 6;
            int powerFastValue = powerFast(run1, run2, n);
            System.out.println("Test powerFast: " + powerFastValue);
        }

        // Test for mergeTopmost2
        public static void testMergeTopmost2() {
            Integer[] A = {1, 3, 5, 2, 4, 6};
            List<int[]> runs = new ArrayList<>();
            runs.add(new int[]{0, 3, 1});
            runs.add(new int[]{3, 3, 1});
            mergeTopmost2(A, runs,NaturalOrder.INSTANCE);
            System.out.println("Test mergeTopmost2: " + A);
        }

        // Test for powerSort
        public static void testPowerSort() {
            Integer [] A = {10, 9, 8, 7, 6, 5, 4, 3, 2, 1};
           powerSort(A, NaturalOrder.INSTANCE);
            System.out.println("Test powerSort: " + A);
        }
    }
